import {
  api_url,
  get,
  post
} from '../../utils/http'
const app = getApp()
Page({
  /**
   * 页面的初始数据
   */
  data: {
    userInfo: {},
    visible: false,
    genders: ['男', '女'],
    genderIndex: 0,
    date: '2016-09-01',
    region: ['广东省', '广州市', '海珠区'],
    globalUserInfo: {},
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      globalUserInfo: app.globalData.userInfo
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getUserFiles()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    this.setData({
      visible: false
    })
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {},

  isShow() {},

  // 选择头像
  onChooseAvatar(e) {
    let that = this
    wx.uploadFile({
      url: 'https://api.ijolijoli.com/api/upload', //仅为示例，非真实的接口地址
      filePath: e.detail.avatarUrl,
      name: 'file',
      formData: {
        'type': 'avatar',
      },
      header: {
        'token': wx.getStorageSync('token')
      }, // header 值
      success (res){
        let data = JSON.parse(res.data)
        console.log(data);
        if(data.code==200){
          post('api/user/save_files',{
            avatar_url:data.data.url
          },(res=>{
            if(res.code==200){
              that.getUserFiles()
              wx.showToast({
                title: '上传成功',
                icon:'none'
              })
            }
          }))
        }
      }
    })
  },
  /**
   * 弹框状态
   */
  onPopupState(e, key, value) {
    if (e) {
      key = e.currentTarget.dataset.key
      value = e.currentTarget.dataset.value
    }
    this.setData({
      [key]: value
    })
  },

  /**
   * 选择性别
   */
  bindGenderChange(e) {
    this.setData({
        ['userInfo.sex']: Number(e.detail.value) + 1
      },
      () => {
        this.setUserFiles()
      }
    )
  },

  /**
   * 选择生日
   */
  bindDateChange: function (e) {
    console.log(e)
    this.setData({
        ['userInfo.birthday']: e.detail.value
        // date: e.detail.value
      },
      () => {
        this.setUserFiles()
      }
    )
  },

  /**
   * 选择所在地
   */
  bindRegionChange: function (e) {
    this.setData({
        region: e.detail.value,
        ['userInfo.city']: e.detail.value.toString()
      },
      () => {
        this.setUserFiles()
      }
    )
  },

  /**
   * 获取用户档案
   * api/user/files
   */
  getUserFiles() {
    get('api/user/files', {}, (res) => {
      this.setData({
        userInfo: res.data
      })
      console.log(res)
    })
  },

  /**
   * 更新用户档案
   * api/user/save_files
   */
  setUserFiles() {
    let {
      real_name,
      birthday,
      sex,
      city,
      nickname
    } = this.data.userInfo
    post(
      'api/user/save_files', {
        real_name,
        birthday,
        sex,
        city,
        nickname
      },
      () => {}
    )
  }
})